
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Home_sectionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const home_sections = await db.home_sections.create(
            {
                id: data.id || undefined,
        
        section_title: data.section_title
        ||
        null
            ,
            
        section_type: data.section_type
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        html_content: data.html_content
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.home_sections.getTableName(),
                belongsToColumn: 'section_images',
                belongsToId: home_sections.id,
            },
            data.section_images,
            options,
        );
        

        return home_sections;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const home_sectionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                section_title: item.section_title
            ||
            null
            ,
            
                section_type: item.section_type
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                html_content: item.html_content
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const home_sections = await db.home_sections.bulkCreate(home_sectionsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < home_sections.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.home_sections.getTableName(),
                    belongsToColumn: 'section_images',
                    belongsToId: home_sections[i].id,
                },
                data[i].section_images,
                options,
            );
        }
        

        return home_sections;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const home_sections = await db.home_sections.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.section_title !== undefined) updatePayload.section_title = data.section_title;
        
        
        if (data.section_type !== undefined) updatePayload.section_type = data.section_type;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.html_content !== undefined) updatePayload.html_content = data.html_content;
        
        
        updatePayload.updatedById = currentUser.id;

        await home_sections.update(updatePayload, {transaction});

        
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.home_sections.getTableName(),
                belongsToColumn: 'section_images',
                belongsToId: home_sections.id,
            },
            data.section_images,
            options,
        );
        

        return home_sections;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const home_sections = await db.home_sections.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of home_sections) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of home_sections) {
                await record.destroy({transaction});
            }
        });


        return home_sections;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const home_sections = await db.home_sections.findByPk(id, options);

        await home_sections.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await home_sections.destroy({
            transaction
        });

        return home_sections;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const home_sections = await db.home_sections.findOne(
            { where },
            { transaction },
        );

        if (!home_sections) {
            return home_sections;
        }

        const output = home_sections.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.home_section_items_home_section = await home_sections.getHome_section_items_home_section({
            transaction
        });
        
        
        
        
        
        
        output.section_images = await home_sections.getSection_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



      {
        model: db.file,
        as: 'section_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.section_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'home_sections',
                        'section_title',
                        filter.section_title,
                    ),
                };
            }
            
            if (filter.html_content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'home_sections',
                        'html_content',
                        filter.html_content,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.section_type) {
                where = {
                    ...where,
                section_type: filter.section_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.home_sections.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'home_sections',
                        'section_title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.home_sections.findAll({
            attributes: [ 'id', 'section_title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['section_title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.section_title,
        }));
    }

    
};

